"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "enUS", {
  enumerable: true,
  get: function () {
    return _enUs.default;
  }
});
Object.defineProperty(exports, "bnBD", {
  enumerable: true,
  get: function () {
    return _bnBd.default;
  }
});
Object.defineProperty(exports, "hiIN", {
  enumerable: true,
  get: function () {
    return _hiIn.default;
  }
});
exports.Converter = void 0;

var _engine = _interopRequireDefault(require("./engine.js"));

var _utils = require("./utils.js");

var _enUs = _interopRequireDefault(require("./locales/en-us.js"));

var _bnBd = _interopRequireDefault(require("./locales/bn-bd.js"));

var _hiIn = _interopRequireDefault(require("./locales/hi-in.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Converter {
  constructor(locale = _enUs.default) {
    this.locale = locale;
  }

  toWords(number, settings = {}) {
    const numberParsed = (0, _utils.parseNumberString)(`${number}`);
    const engine = new _engine.default(this.locale);
    const mergedLocale = { ...this.locale,
      ...settings
    };
    let result = engine.toWords(numberParsed.whole, mergedLocale);

    if (numberParsed.fraction != "0") {
      result += ` ${mergedLocale.names.point} ` + [...numberParsed.fraction].map(digit => engine.toWords(digit, mergedLocale)).join(" ");
    }

    if (numberParsed.sign == '-') {
      result = mergedLocale.names.minus + " " + result;
    }

    return result;
  }

}

exports.Converter = Converter;